#include "Regedit.h"


Regedit::Regedit(void)
{
}


Regedit::~Regedit(void)
{

}

bool Regedit::CreateSubKey(HKEY RootKey, const std::wstring& Key){

	HKEY phKey = NULL;
	LONG res = RegCreateKeyEx(
		RootKey,
		Key.c_str(),
		NULL,
		NULL,
		REG_OPTION_NON_VOLATILE,
		KEY_CREATE_SUB_KEY|KEY_WOW64_32KEY,
		NULL,
		&phKey,
		NULL
		);

	if( res != ERROR_SUCCESS )
	{
		GetLastErrorMessage(res);
		return 0;
	}

	RegCloseKey(phKey);
	return 1;


}
bool Regedit::DeleteSubKey(HKEY RootKey, const std::wstring& Key){
	LONG res = RegDeleteKeyEx(
		RootKey,
		Key.c_str(),
		KEY_WOW64_32KEY,
		NULL
		);
	if( res != ERROR_SUCCESS )
	{
		GetLastErrorMessage(res);
		return 0;
	}
	return 1;

}
bool Regedit::DeleteTree(HKEY RootKey, const std::wstring& Key){
	LONG res = RegDeleteTree(
		RootKey,
		Key.c_str()
		);
	if( res != ERROR_SUCCESS )
	{
		GetLastErrorMessage(res);
		return 0;
	}
	return 1;
}
bool Regedit::SetValue( HKEY RootKey , const std::wstring& path, const std::wstring& value_name,DWORD type_value,DWORD value){

	LONG res = RegSetKeyValue(
		RootKey,
		path.c_str(),
		value_name.c_str(),
		type_value,
		(BYTE*)&value,
		sizeof(DWORD)
		);

	if( res != ERROR_SUCCESS )
	{
		GetLastErrorMessage(res);
		return 0;
	}
	return 1;
}
bool Regedit::SetValue( HKEY RootKey , const std::wstring& path, const std::wstring& value_name,DWORD type_value ,const std::wstring& value){

	LONG res = RegSetKeyValue(
		RootKey,
		path.c_str(),
		value_name.c_str(),
		type_value,
		(BYTE*)value.c_str(),
		(sizeof(wchar_t)*value.length())
		);


	if( res != ERROR_SUCCESS )
	{
		GetLastErrorMessage(res);
		return 0;
	}
	return 1;
}
bool Regedit::SetValue( HKEY RootKey , const std::wstring& path, const std::wstring& value_name,DWORD type_value , BYTE* value ,DWORD size){

	LONG res = RegSetKeyValue(
		RootKey,
		path.c_str(),
		value_name.c_str(),
		type_value,
		value,
		size
		);

	if( res != ERROR_SUCCESS )
	{
		GetLastErrorMessage(res);
		return 0;
	}
	return 1;


}
bool Regedit::GetSubKeys( HKEY RootKey , const std::wstring& path,bool ReadSubDir, std::vector<std::wstring>* result){

	HKEY hKey;
	LONG ret	= RegOpenKeyEx(	RootKey,
		path.c_str(),
		NULL,
		KEY_READ,
		&hKey );

	if( ret != ERROR_SUCCESS )
	{
		GetLastErrorMessage(ret);
		return 0;
	}

	DWORD    cSubKeys		= NULL; 

	ret = ::RegQueryInfoKey(hKey,                   // key handle 
		NULL,					// buffer for class name 
		NULL,					// size of class string 
		NULL,                   // reserved 
		&cSubKeys,				// number of subkeys 
		NULL,					// longest subkey size 
		NULL,					// longest class string 
		NULL,               // number of values for this key 
		NULL,       // longest value name 
		NULL,        // longest value data 
		NULL,					// security descriptor 
		NULL );					// last write time 
	if( ret != ERROR_SUCCESS )
	{
		RegCloseKey( hKey );
		GetLastErrorMessage(ret);
		return 0;
	}


	for ( DWORD i = 0; i < cSubKeys && ret == ERROR_SUCCESS; i++ ) 
	{ 
		std::wstring achKey;
		achKey.resize( MAX_KEY_LENGTH );
		DWORD cbName	= MAX_KEY_LENGTH;
		ret	= RegEnumKeyEx(	hKey, 
			i,
			&achKey[ 0 ], 
			&cbName, 
			NULL, 
			NULL, 
			NULL, 
			NULL );

		if( ret == ERROR_SUCCESS )
		{
			achKey.resize( cbName );
			result->push_back( path+L"\\"+ achKey );
			if(ReadSubDir == READ_SUBDERICTORIES){
				this->GetSubKeys(RootKey,path+L"\\"+ achKey,READ_SUBDERICTORIES,result);
			}
		}

	}
	RegCloseKey( hKey );
	return 1;


}
bool Regedit::GetSubKeys( HKEY RootKey, const std::wstring& path, std::vector<std::wstring>* result){
	return this->GetSubKeys(RootKey,path,0,result);
}
bool Regedit::GetValues( HKEY RootKey, const std::wstring& path, bool ReadSubDir, std::vector<REGDATA> * result){

	HKEY hKey;
	LONG ret	= RegOpenKeyEx(	RootKey,
		path.c_str(),
		NULL,
		KEY_READ,
		&hKey );

	if( ret != ERROR_SUCCESS )
	{
		GetLastErrorMessage(ret);
		return 0;
	}

	DWORD    cSubKeys		= NULL; 
	DWORD    cValues		= NULL; 
	DWORD    cchMaxValueName	= NULL; 
	DWORD    cbMaxValueData	= NULL; 


	ret = ::RegQueryInfoKey(hKey,                   // key handle 
		NULL,					// buffer for class name 
		NULL,					// size of class string 
		NULL,                   // reserved 
		&cSubKeys,				// number of subkeys 
		NULL,					// longest subkey size 
		NULL,					// longest class string 
		&cValues,               // number of values for this key 
		&cchMaxValueName,       // longest value name 
		&cbMaxValueData,        // longest value data 
		NULL,					// security descriptor 
		NULL );					// last write time 
	if( ret != ERROR_SUCCESS )
	{
		RegCloseKey( hKey );
		GetLastErrorMessage(ret);
		return 0;
	}



	for ( DWORD i = 0; i < cValues && ret == ERROR_SUCCESS; i++ ) 
	{ 
		REGDATA	d;
		d.name_value.resize	( cchMaxValueName + 1 );
		d.value.resize		( cbMaxValueData + 1 );
		DWORD	cchValue	= cchMaxValueName + 1; 
		DWORD	cbData		= cbMaxValueData + 1;
		ret = ::RegEnumValue(	hKey, 
			i, 
			&d.name_value[ 0 ], 
			&cchValue, 
			NULL, 
			&d.type_value,
			&d.value[ 0 ],
			&cbData );
		if( ret == ERROR_SUCCESS )
		{
			d.path = path;
			d.name_value.resize( cchValue ); //    
			d.value.resize	( cbData ); //    
			result->push_back(d);
		}
	}

	if(ReadSubDir == READ_SUBDERICTORIES){
		for ( DWORD i = 0; i < cSubKeys && ret == ERROR_SUCCESS; i++ ) 
		{ 
			std::wstring achKey;
			achKey.resize( MAX_KEY_LENGTH );
			DWORD cbName	= MAX_KEY_LENGTH;
			ret	= RegEnumKeyEx(	hKey, 
				i,
				&achKey[ 0 ], 
				&cbName, 
				NULL, 
				NULL, 
				NULL, 
				NULL );

			if( ret == ERROR_SUCCESS )
			{
				achKey.resize( cbName );
				this->GetValues(RootKey,path+L"\\"+ achKey,READ_SUBDERICTORIES,result);
			}

		}
	}
	RegCloseKey( hKey );
	return 1;

}
bool Regedit::GetValues( HKEY RootKey, const std::wstring& path, std::vector<REGDATA> * result){
	return this->GetValues(RootKey, path,0,result);
}
bool Regedit::GetValue( HKEY RootKey, const std::wstring& path,const std::wstring& value_name ,PREGDATA result){

	HKEY hKey;
	LONG ret	= RegOpenKeyEx(	RootKey,
		path.c_str(),
		NULL,
		KEY_READ,
		&hKey );

	if( ret != ERROR_SUCCESS )
	{
		GetLastErrorMessage(ret);
		return 0;
	}

	DWORD    cbMaxValueData	= NULL; 


	ret = ::RegQueryInfoKey(hKey,                   // key handle 
		NULL,					// buffer for class name 
		NULL,					// size of class string 
		NULL,                   // reserved 
		NULL,				// number of subkeys 
		NULL,					// longest subkey size 
		NULL,					// longest class string 
		NULL,               // number of values for this key 
		NULL,       // longest value name 
		&cbMaxValueData,        // longest value data 
		NULL,					// security descriptor 
		NULL );					// last write time 
	if( ret != ERROR_SUCCESS )
	{
		RegCloseKey( hKey );
		GetLastErrorMessage(ret);
		return 0;
	}

	DWORD	cbData		= (cbMaxValueData + 1);
	result->value.resize( cbMaxValueData + 1 );

	ret = RegGetValue(
		RootKey,
		path.c_str(),
		value_name.c_str(),
		RRF_RT_ANY,
		&result->type_value,
		&result->value[ 0 ],
		&cbData
		);

	if( ret != ERROR_SUCCESS )
	{
		RegCloseKey( hKey );
		GetLastErrorMessage(ret);
		return 0;
	}

	result->value.resize	( cbData ); //    
	result->path = path;
	result->name_value = value_name;

	RegCloseKey( hKey );
	return 1;
}
bool Regedit::DellValue( HKEY RootKey, const std::wstring& path, const std::wstring& value_name ){

	LONG res = RegDeleteKeyValue(
		RootKey,
		path.c_str(),
		value_name.c_str()
		);
	if( res != ERROR_SUCCESS )
	{
		GetLastErrorMessage(res);
		return 0;
	}

	return 1;
}

std::wstring Regedit::GetError(void){
	return this->error;
}
void Regedit::GetLastErrorMessage(DWORD err){
	LPVOID lpmsg = 0;
		FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			__in_opt  NULL,
			__in      err,
			__in      MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			__out     ( LPWSTR )&lpmsg,
			__in      NULL,
			__in_opt  NULL
			);

		this->error = (wchar_t *)lpmsg;
		this->error.erase(this->error.length()-2,this->error.length()-1); //     FormatMessage
		LocalFree( lpmsg );
}