#pragma once
#include <Windows.h>
#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>



#define MAX_KEY_LENGTH 255
#define MAX_VALUE_NAME 16383

enum{DONT_READ_SUBDERICTORIES,READ_SUBDERICTORIES};

typedef struct _DATA
{
	std::wstring path;
	std::wstring name_value;
	DWORD type_value;
	std::vector< BYTE >	value;

	//----------------------------------------
	void toDWORD(DWORD& res){
		res = this->value.at(0);
	}
	void toWstring(std::wstring& res){
		res.clear();
		for (int i = 0; i < this->value.size(); i++)
		{
			if(!(i%2)){
				res+=this->value.at(i);
			}
		}
	}

} REGDATA, *PREGDATA;

class Regedit
{
public:

	/*
	predefined keys:
	HKEY_CLASSES_ROOT
	HKEY_CURRENT_CONFIG
	HKEY_CURRENT_USER
	HKEY_LOCAL_MACHINE
	HKEY_USERS
	*/

	bool CreateSubKey( HKEY /* */, const std::wstring& /* /*/ );
	bool DeleteSubKey( HKEY /* */, const std::wstring& /* /*/);
	bool DeleteTree( HKEY /* */, const std::wstring& /* /*/);
	bool GetSubKeys( HKEY /* */, const std::wstring& /* /*/, bool /*  1\0*/, std::vector<std::wstring>* /**/);
	bool GetSubKeys( HKEY /* */, const std::wstring& /* /*/, std::vector<std::wstring>* /**/);
	bool SetValue( HKEY /* */, const std::wstring& /* /*/, const std::wstring& /* */,DWORD /* */ ,DWORD /* */);
	bool SetValue( HKEY /* */, const std::wstring& /* /*/, const std::wstring& /* */,DWORD /* */,BYTE* /* */,DWORD /*   */);
	bool SetValue( HKEY /* */, const std::wstring& /* /*/, const std::wstring& /* */,DWORD /* */,const std::wstring& /* */);
	bool GetValue( HKEY /* */, const std::wstring& /* /*/, const std::wstring& /* */, PREGDATA /**/); 
	bool DellValue( HKEY /* */, const std::wstring& /* /*/, const std::wstring& /* */ );
	bool GetValues( HKEY /* */, const std::wstring& /* /*/, bool /*  1\0*/, std::vector<REGDATA> * /**/);
	bool GetValues( HKEY /* */, const std::wstring& /* /*/, std::vector<REGDATA> * /**/);

	std::wstring GetError(void);

	Regedit(void);
	~Regedit(void);

private:


	void GetLastErrorMessage(DWORD);
	std::wstring error;
};

